#!/usr/bin/perl -w


# only for claen files (coming from Gb for example) or *.WOV from clean.pl
# call an all-againts-all blast; 
# class sequences into (A) unique, grouped (gives all hits), or unBLASTable; 
# class sequences into (A) unique, grouped (gives all hits), or unBLASTable; and redundant
# class sequences into (A) unique, grouped (gives lagre goups), or unBLASTable; 


  use warnings;
  use strict;
  use sub_ms_group;

  my $USAGE = "USAGE : $0 filename_with_pathway folder_for_the_outfiles E_value_for_blast limit_of_identity_for_redundants pathway_for_Blast pathway_for_clustal\n\n";

  unless ( scalar@ARGV == 6 )
  {
      print $USAGE;
      exit;
  }

  my $filename = $ARGV[0];
  my $outfolder =  $ARGV[1];
  my $Eblast =  $ARGV[2];
  my $redlimit = $ARGV[3];
  my $path_blast =  $ARGV[4];
  my $path_clustal = $ARGV[5];

my $gap = 'with';
 
     my %clas_seq = (); 
     my %group_seq = ();
     my %clustal = ();
     my %large_group = ();

# clas_seq: unique, unBLASTable or grouped
# group_seq: only grouped sequences, gives all reciproc hits for each sequence
# clusatl: same as group_seq, but contains starnd (e.g. PlusACA002, MinusACA054,)

print "\nGrouping sequences of $filename\n";
 
     group_blast_simple($filename, $outfolder, $Eblast, $redlimit, $path_blast, \%clas_seq, \%group_seq, \%clustal);

#     print_hachage_into_file(\%clas_seq, 'temp/clas_hach');
#     print_hachage_into_file(\%group_seq, 'temp/group_seq');
#     print_hachage_into_file(\%clustal, 'temp/clustal');

# delete_blast_file('datatemp/');

     copie_hachage(\%group_seq, \%large_group);
     merge_groups_1(\%large_group);
#     print_hachage(\%large_group);

     numbering_large_group(\%large_group, \%clas_seq);
#     print_hachage(\%clas_seq);

# identify redundant sequences
  my ($redundants, $idem_pairs) = check_redundants(\%clustal, $filename, $outfolder, $redlimit, $gap, $path_clustal);
#  print "\nredundant sequences: $redundants\n$idem_pairs\n";
  
# correct clustal for redundants: gives redundant_$code if seq is redundants; unique is all but one hits are redundant
  correct_redundants(\%clustal, $redundants, $idem_pairs);

#     print_hachage(\%clas_seq);
#    print_hachage(\%group_seq);
#    print_hachage(\%clustal);

     print_clas_into_file(\%clas_seq, \%group_seq, \%clustal, $filename, $outfolder);

 delete_temp_clust_file($outfolder);


  exit;


##############################################################

sub group_blast_simple

{
# blast fasta file against the same file
# extract matches 
# group sequences into unBLASTable, unique or groupped cathegories

  use warnings;
  use strict;
  use sub_ms_group;
   
  my ($filename, $outfolder, $Eblast, $redlimit, $path_blast, $clas_seq, $group_seq, $clustal) = @_;

  $filename =~ /\/.*\./;
  my $filename_beg = $&;
  $filename_beg =~ s/\///;
  $filename_beg =~ s/\.//;

## blast the sequence file againts itself XXX.txt contains the results of the blast
  call_blast($filename, $Eblast, $path_blast, $outfolder);

  delete_blast_file($outfolder);


## sort out the result of the blast: 
#Clas_seq: one of three chategories for all sequences: unique, unBLASTable or grouped
# group_seq contains all the hits produced by the sequence (only for groupped sequences)
## clustal will be used for checking redundant. It is the same as group_seq, but
## contains the strand (plus or Minus) compared to the sequence

  first_group($filename, \%$clas_seq, \%$group_seq, \%$clustal, $outfolder);

#  delete_blast_txt('temp/');

# check reciproc hits and eliminates non-reciprocs from group-seq and clustal
  check_reciproc_hits(\%$group_seq, \%$clustal);



# correct clas_seq into unique if sequence was groupes only with non-eciproc hits# Correct group_seq and clustal{$code}= ''; if sequence became unique after eliminating non-reciproc hits
  correct_for_non_reciproc(\%$group_seq, \%$clas_seq, \%$clustal);

}


############################################################


sub one_seq_result
{
#    read the result of the blast for one sesquence from file

    my $filename = @_; 


    my $sep_entree = $/;
    $/ = "Reference:";
    my $res_seq = <BLASTRES>;
    $/ = $sep_entree;
    return $res_seq;
}


##########################################################
